import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;


public class APenguinJumpedOverTheMoon {

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader (
				new FileReader ("APenguinJumpedOverTheMoonIN.txt"));
		
		while (br.ready()) {
			String line = br.readLine();
			String[] tokens = line.split(" ");
			int launch_x = Integer.parseInt(tokens[0]);
			int launch_y = Integer.parseInt(tokens[1]);
			int land_r = Integer.parseInt(tokens[2]);
			int land_x = Integer.parseInt(tokens[3]);
			int land_y = Integer.parseInt(tokens[4]);
			int land_w = Integer.parseInt(tokens[5]);
			int land_h = Integer.parseInt(tokens[6]);
			
			System.out.println(canWeSuccede(launch_x, launch_y, land_r,
											land_x, land_y, land_w, land_h));
		}
		
		br.close();
	}
	public static boolean containsPoint(int c_x, int c_y, int r, 
												int x, int y) {
		return (c_x-x)*(c_x-x)+ (c_y - y)*(c_y - y) <= r*r;
	}
	public static boolean axisOverlaps(int p11, int p12, int p21, int p22) {
		int width = Math.max(p12, p22) - Math.min(p11, p21);
		return width <= (p12 - p11) + (p22 - p21);
	}
	public static boolean canWeSuccede(	int launch_x, int launch_y, int land_r,
									int land_x, int land_y, int land_w, 
									int land_h) {
		if (containsPoint(launch_x, launch_y, land_r, land_x, land_y) ||
			containsPoint(launch_x, launch_y, land_r, land_x + land_w, land_y)||
			containsPoint(launch_x, launch_y, land_r, land_x, land_y - land_h)||
			containsPoint(launch_x, launch_y, land_r, 
							land_x+land_w, land_y-land_h)) {
			return true;
		}
		
		int x1 = launch_x - land_r;
		int x2 = launch_x + land_r;
		int y1 = launch_y - land_r;
		int y2 = launch_y + land_r;
		if (launch_x < land_x && launch_y > land_y ||
			launch_x < land_x && launch_y < land_y - land_h ||
			launch_x > land_x + land_w && launch_y > land_y ||
			launch_x > land_x + land_w && launch_y < land_y - land_h) {
			return false;
		}
		if (axisOverlaps(x1, x2, land_x, land_x + land_w) && 
			axisOverlaps(y1, y2, land_y - land_h, land_y)) {
			return true;
		}
		return false;
	}
}
