import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class Concert {
    // Before submitting, make sure the main method hasn't been changed!
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader
            ("ConcertIN.txt"));

        while (br.ready()) {
            String base = br.readLine();
            String height = br.readLine();
            String[] pillars = br.readLine().split(" ");
            double[] pillarDoubles = new double[pillars.length];
            for (int i = 0; i < pillars.length; i++) {
                pillarDoubles[i] = Double.parseDouble(pillars[i]);
            }

            System.out.println(computeSeatingCapacity(
                Double.parseDouble(base),
                Double.parseDouble(height),
                pillarDoubles
            ));
        }
    }

    // Fill out the body of this method
    public static int computeSeatingCapacity(double base, double height, double[] pillars) {
        double area = base * height / 2;
        double apexX = base / 2;
        double apexY = height;
        for (int i = 0; i < pillars.length; i += 3) {
            double x1 = pillars[i];
            double x2 = pillars[i + 1];
            double y = pillars[i + 2];

            double b1 = x2 - x1;
            double left = (y / (apexY - y)) * (x1 - apexX);
            double right = (y / (apexY - y)) * (x2 - apexX);
            double b2 = x2 - x1 - left + right;
            double trapArea = (b1 + b2) * y / 2;
            area -= trapArea;
        }
        return (int)area * 21;
    }
}
