import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;


public class PenguinByNorthPenguin {

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader (
				new FileReader ("PenguinByNorthPenguinIN.txt"));
		
		while (br.ready()) {
			StringTokenizer st = new StringTokenizer(br.readLine());
			double dir = Double.parseDouble(st.nextToken());
			double tolerance = Double.parseDouble(st.nextToken());
			System.out.println(getDirection(dir, tolerance));
		}
		
		br.close();
	}
	
	public static String getDirRec(char low, char hi, double tar, 
								double tol, double cur, double step) {
		if (Math.abs(tar-cur) <= tol) {
			return "";
		}
		if (cur < tar) {
			return getDirRec(low, hi, tar, tol, cur + step, step/2) + hi;
		}
		return getDirRec(low, hi, tar, tol, cur - step, step/2) + low;
		
	}
	public static String getDirection(double dir, double tolerance) {
		if (dir <= tolerance || 360 - dir <= tolerance) {
			return "N";
		}
		if (Math.abs(dir - 180) <= tolerance) {
			return "S";
		}
				
		if (dir < 90) {
			return getDirRec('N', 'E', dir, tolerance, 90, 45) + 'E';
		}
		if (dir < 180) {
			return getDirRec('E', 'S', dir, tolerance, 90, 45) + 'E';
		}
		if (dir < 270) {
			return getDirRec('S', 'W', dir, tolerance, 270, 45) + 'W';
		}
		return getDirRec('W', 'N', dir, tolerance, 270, 45) + 'W';
		
	}

}
