import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class PenguinMathematics {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(
            new FileReader("PenguinMathematicsIN.txt"));
        
        while (br.ready()) {
            String data = br.readLine();
            System.out.println(manipulateAbacus(data));
        }
    }

    public static String manipulateAbacus(String input) {
        String[] abaci = input.split(";");
        String first = abaci[0];
        String second = abaci[1];
        int sum = abacusToInt(first) + abacusToInt(second);
        return intToAbacus(sum);
    }

    static int abacusToInt(String abacus) {
        String[] rows = abacus.split(",");
        int value = 0;
        for (int i = 0; i < rows.length; i++) {
            String row = rows[i];
            int digit = row.indexOf(' '); // index of space character
            value = 10 * value + digit;
        }
        return value;
    }

    static String intToAbacus(int value) {
        String abacus = "";
        do {
            int digit = value % 10; // grab bottom digit
            if (abacus == "") {
                abacus = digitToAbacus(digit);
            } else {
                abacus = digitToAbacus(digit) + "," + abacus;
            }
            value = value / 10; // truncate bottom digit
        } while (value > 0);
        return abacus;
    }

    static String digitToAbacus(int digit) {
        String abacus = "";
        for (int i = 0; i < 10; i++) {
            if (digit == i) {
                abacus += " ";
            } else {
                abacus += "*";
            }
        }
        return abacus;
    }
}
